// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSC1M/16AI32SSC1M_Linux_1.x.x.x_DN/samples/id/perform.c $
// $Rev: 53822 $
// $Date: 2023-10-04 16:25:17 -0500 (Wed, 04 Oct 2023) $

// 16AI32SSC1M: Sample Application: source file

#include "main.h"



//*****************************************************************************
static void _input_modes(void)
{
	gsc_label("Input Modes");
	printf("Differential, Single Ended, Zero Test, +Vref Test\n");
}



//*****************************************************************************
static void _voltage_ranges(void)
{
	gsc_label("Voltage Ranges");
	printf("+-10V, +-5V, +-2.5V, +-1.25V\n");
}



//*****************************************************************************
static void _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Rate Generator(s), External, Software\n");
}



//*****************************************************************************
static void _sampling_modes(void)
{
	gsc_label("Sampling Modes");
	printf("Continuous, Burst, Single Shot (software)\n");
}



//*****************************************************************************
static void _time_tag_support(void)
{
	gsc_label("Time Tag Support");
	printf("Yes\n");
}



//*****************************************************************************
static void _low_latency_support(void)
{
	gsc_label("Low Latency Support");
	printf("Yes\n");
}



//*****************************************************************************
static int _id_board_reg(const args_t* args)
{
	gsc_reg_def_t			list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	int	errs;

	printf("\n");
	ptr	= ai32ssc1m_reg_get_def_id(AI32SSC1M_GSC_BCFGR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, ai32ssc1m_reg_read);
	}
	else
	{
		errs	= 1;
		printf(	"FAIL <---  (%d. ai32ssc1m_reg_get_def_id, AI32SSC1M_GSC_BCFGR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= ai32ssc1m_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Board Features");
	printf("\n");

	gsc_label_level_inc();

	_input_modes();
	_voltage_ranges();
	_clocking_sources();
	_sampling_modes();
	_time_tag_support();
	_low_latency_support();

	for (i = 0; i < AI32SSC1M_IOCTL_QUERY_LAST; i++)
		errs	+= ai32ssc1m_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_board_reg(args);
	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


