// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSC1M/16AI32SSC1M_Linux_1.x.x.x_DN/samples/savedata/main.h $
// $Rev: 53820 $
// $Date: 2023-10-04 16:23:47 -0500 (Wed, 04 Oct 2023) $

// 16AI32SSC1M: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "16ai32ssc1m_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))
#define	CHAN_TAG_EXCLUDE		1
#define	CHAN_TAG_ONLY			2



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	chan_tag;		// Channel tag processing.
	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	decimal;		// Save data in decimal format? Default is hex.
	s32	force_save;		// Save data even if there are errors?
	s32	fsamp;			// Desired sample rate.
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	repeat;			// repeat data retrieval this many times
	s32	test_limit;		// for continuous testing

	int	fd;				// File descriptor for device to access.

	// Device Settings

	s32	ai_mode;		// Analog Input Mode
	s32	chan_active;
	s32	chan_first;
	s32	chan_last;
	s32	chan_single;
	s32	io_mode;
} args_t;



// prototypes *****************************************************************

int	perform_tests(const args_t* args);



#endif
