// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSC1M/16AI32SSC1M_Linux_1.x.x.x_DN/samples/wait/wait_gsc.c $
// $Rev: 53821 $
// $Date: 2023-10-04 16:24:27 -0500 (Wed, 04 Oct 2023) $

// 16AI32SSC1M: Sample Application: source file

#include "main.h"



//*****************************************************************************
int wait_gsc_irq0_initialize_test(int fd)
{
	int	errs;

	errs	= ai32ssc1m_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
int wait_gsc_irq0_autocal_test(int fd)
{
	int	errs	= 0;

	errs	+= ai32ssc1m_initialize	(fd, -1, 0);
	errs	+= ai32ssc1m_autocal	(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
int wait_gsc_irq0_sync_start_test(int fd)
{
	int	errs	= 0;

	errs	+= ai32ssc1m_initialize	(fd, -1, 0);
	errs	+= ai32ssc1m_adc_clk_src(fd, -1, 0, AI32SSC1M_ADC_CLK_SRC_BCR,	NULL);
	errs	+= ai32ssc1m_irq0_sel	(fd, -1, 0, AI32SSC1M_IRQ0_SYNC_START, NULL);
	errs	+= ai32ssc1m_adc_enable	(fd, -1, 0, AI32SSC1M_ADC_ENABLE_YES, NULL);
	errs	+= ai32ssc1m_input_sync	(fd, -1, 0);

	if (errs)
		printf("FAIL <---\n");

	return(errs);
}



//*****************************************************************************
int wait_gsc_irq0_sync_done_test(int fd)
{
	int	errs	= 0;

	errs	+= ai32ssc1m_initialize	(fd, -1, 0);
	errs	+= ai32ssc1m_adc_clk_src(fd, -1, 0, AI32SSC1M_ADC_CLK_SRC_BCR,	NULL);
	errs	+= ai32ssc1m_irq0_sel	(fd, -1, 0, AI32SSC1M_IRQ0_SYNC_DONE, NULL);
	errs	+= ai32ssc1m_adc_enable	(fd, -1, 0, AI32SSC1M_ADC_ENABLE_YES, NULL);
	errs	+= ai32ssc1m_input_sync	(fd, -1, 0);

	if (errs)
		printf("FAIL <---\n");
	else
		gsc_time_sleep_ms(100);

	return(errs);
}



//*****************************************************************************
int wait_gsc_irq0_burst_start_test(int fd)
{
	int	errs	= 0;

	errs	+= ai32ssc1m_initialize	(fd, -1, 0);
	errs	+= ai32ssc1m_burst_size	(fd, -1, 0, 1, NULL);
	errs	+= ai32ssc1m_burst_sync	(fd, -1, 0, AI32SSC1M_BURST_SYNC_BCR, NULL);
	errs	+= ai32ssc1m_adc_clk_src(fd, -1, 0, AI32SSC1M_ADC_CLK_SRC_RAG, NULL);
	errs	+= ai32ssc1m_rag_enable	(fd, -1, 0, AI32SSC1M_GEN_ENABLE_YES, NULL);
	errs	+= ai32ssc1m_irq0_sel	(fd, -1, 0, AI32SSC1M_IRQ0_BURST_START, NULL);
	errs	+= ai32ssc1m_adc_enable	(fd, -1, 0, AI32SSC1M_ADC_ENABLE_YES, NULL);
	errs	+= ai32ssc1m_input_sync	(fd, -1, 0);

	if (errs)
		printf("FAIL <---\n");
	else
		gsc_time_sleep_ms(1000);

	return(errs);
}



//*****************************************************************************
int wait_gsc_irq0_burst_done_test(int fd)
{
	int	errs	= 0;

	errs	+= ai32ssc1m_initialize	(fd, -1, 0);
	errs	+= ai32ssc1m_burst_size	(fd, -1, 0, 1, NULL);
	errs	+= ai32ssc1m_burst_sync	(fd, -1, 0, AI32SSC1M_BURST_SYNC_BCR, NULL);
	errs	+= ai32ssc1m_adc_clk_src(fd, -1, 0, AI32SSC1M_ADC_CLK_SRC_RAG, NULL);
	errs	+= ai32ssc1m_rag_enable	(fd, -1, 0, AI32SSC1M_GEN_ENABLE_YES, NULL);
	errs	+= ai32ssc1m_irq0_sel	(fd, -1, 0, AI32SSC1M_IRQ0_BURST_DONE, NULL);
	errs	+= ai32ssc1m_adc_enable	(fd, -1, 0, AI32SSC1M_ADC_ENABLE_YES, NULL);
	errs	+= ai32ssc1m_input_sync	(fd, -1, 0);

	if (errs)
		printf("FAIL <---\n");
	else
		gsc_time_sleep_ms(1000);

	return(errs);
}



//*****************************************************************************
int wait_gsc_irq1_in_buf_thr_l2h_test(int fd)
{
	int	errs	= 0;

	errs	+= ai32ssc1m_initialize		(fd, -1, 0);
	errs	+= ai32ssc1m_ai_buf_thr_lvl	(fd, -1, 0, 16, NULL);
	errs	+= ai32ssc1m_irq1_sel		(fd, -1, 0, AI32SSC1M_IRQ1_IN_BUF_THR_L2H, NULL);
	errs	+= ai32ssc1m_adc_clk_src	(fd, -1, 0, AI32SSC1M_ADC_CLK_SRC_RAG,	NULL);
	errs	+= ai32ssc1m_rag_enable		(fd, -1, 0, AI32SSC1M_GEN_ENABLE_YES, NULL);
	errs	+= ai32ssc1m_adc_enable		(fd, -1, 0, AI32SSC1M_ADC_ENABLE_YES, NULL);

	if (errs)
		printf("FAIL <---\n");
	else
		gsc_time_sleep_ms(1000);

	return(errs);
}



//*****************************************************************************
int wait_gsc_irq1_in_buf_thr_h2l_test(int fd)
{
	int	errs	= 0;

	errs	+= ai32ssc1m_initialize		(fd, -1, 0);
	errs	+= ai32ssc1m_ai_buf_thr_lvl	(fd, -1, 0, 16, NULL);
	errs	+= ai32ssc1m_irq1_sel		(fd, -1, 0, AI32SSC1M_IRQ1_IN_BUF_THR_H2L, NULL);
	errs	+= ai32ssc1m_adc_enable		(fd, -1, 0, AI32SSC1M_ADC_ENABLE_YES, NULL);
	errs	+= ai32ssc1m_rag_enable		(fd, -1, 0, AI32SSC1M_GEN_ENABLE_YES, NULL);
	errs	+= ai32ssc1m_adc_clk_src	(fd, -1, 0, AI32SSC1M_ADC_CLK_SRC_RAG,	NULL);
	gsc_time_sleep_ms(1000);
	errs	+= ai32ssc1m_rag_enable		(fd, -1, 0, AI32SSC1M_GEN_ENABLE_NO, NULL);
	errs	+= ai32ssc1m_ai_buf_clear	(fd, -1, 0);

	if (errs)
		printf("FAIL <---\n");
	else
		gsc_time_sleep_ms(1000);

	return(errs);
}



//*****************************************************************************
int wait_gsc_irq1_in_buf_overflow_test(int fd)
{
	s32	enable_a;
	s32	enable_b;
	int	errs	= 0;
	s32	nrate_a;
	s32	nrate_b;
	s32	src;
	s32	src_b;

	errs	+= ai32ssc1m_initialize			(fd, -1, 0);
	errs	+= ai32ssc1m_irq1_sel			(fd, -1, 0, AI32SSC1M_IRQ1_IN_BUF_OVR_UNDR, NULL);
	errs	+= ai32ssc1m_fsamp_ai_compute	(fd, -1, 0, 100000, &src, &src_b, &nrate_a, &nrate_b, &enable_a, &enable_b, NULL);
	errs	+= ai32ssc1m_adc_clk_src		(fd, -1, 0, src,		NULL);
	errs	+= ai32ssc1m_rag_nrate			(fd, -1, 0, nrate_a,	NULL);
	errs	+= ai32ssc1m_rag_enable			(fd, -1, 0, enable_a,	NULL);
	errs	+= ai32ssc1m_rbg_clk_src		(fd, -1, 0, src_b,		NULL);
	errs	+= ai32ssc1m_rbg_nrate			(fd, -1, 0, nrate_b,	NULL);
	errs	+= ai32ssc1m_rbg_enable			(fd, -1, 0, enable_b,	NULL);
	errs	+= ai32ssc1m_adc_enable			(fd, -1, 0, AI32SSC1M_ADC_ENABLE_YES, NULL);

	if (errs)
		printf("FAIL <---\n");
	else
		gsc_time_sleep_ms(1000);

	return(errs);
}



//*****************************************************************************
int wait_gsc_irq1_in_buf_ubderflow_test(int fd)
{
	int	errs	= 0;
	u32	idbr;

	errs	+= ai32ssc1m_initialize	(fd, -1, 0);
	errs	+= ai32ssc1m_irq1_sel	(fd, -1, 0, AI32SSC1M_IRQ1_IN_BUF_OVR_UNDR, NULL);
	errs	+= ai32ssc1m_rag_enable	(fd, -1, 0, AI32SSC1M_GEN_ENABLE_YES, NULL);
	errs	+= ai32ssc1m_reg_read	(fd, -1, 0, AI32SSC1M_GSC_IDBR, &idbr);

	if (errs)
		printf("FAIL <---\n");
	else
		gsc_time_sleep_ms(1000);

	return(errs);
}


