// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSC1M/16AI32SSC1M_Linux_1.x.x.x_DN/utils/auto_cal_status.c $
// $Rev: 53814 $
// $Date: 2023-10-04 16:21:01 -0500 (Wed, 04 Oct 2023) $

// 16AI32SSC1M: Utilities: source file

#include "main.h"



// Retained for backwards compatibility.

/******************************************************************************
*
*	Function:	ai32ssc1m_auto_cal_status
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSC1M_IOCTL_AUTO_CAL_STATUS service.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the board to access. Ignore if < 0.
*
*		verbose	0: errors only, !0: all output
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai32ssc1m_auto_cal_status(int fd, int index, int verbose,s32* get)
{
	char		buf[128];
	int			errs;
	const char*	ptr;
	s32			ret;
	s32			set;

	if (verbose)
		gsc_label_index("Auto Cal Status", index);

	ret		= ai32ssc1m_ioctl(fd, AI32SSC1M_IOCTL_AUTO_CAL_STATUS, &set);
	errs	= ret ? 1 : 0;

	switch (set)
	{
		default:

			errs	= 1;
			ptr		= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case AI32SSC1M_AUTO_CAL_STATUS_BUSY:

			ptr	= "Busy";
			break;

		case AI32SSC1M_AUTO_CAL_STATUS_FAIL:

			ptr	= "Fail";
			break;

		case AI32SSC1M_AUTO_CAL_STATUS_PASS:

			ptr	= "Pass";
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", ptr);

	if (get)
		get[0]	= set;

	return(errs);
}


