// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSC1M/16AI32SSC1M_Linux_1.x.x.x_DN/utils/chan_active.c $
// $Rev: 42824 $
// $Date: 2018-05-17 16:42:27 -0500 (Thu, 17 May 2018) $

// 16AI32SSC1M: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssc1m_chan_active
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSC1M_IOCTL_CHAN_ACTIVE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	ai32ssc1m_chan_active(int fd, int index, int verbose, s32 set, s32* get)
{
	char	buf[128];
	int		errs;
	int		ret;

	if (verbose)
		gsc_label_index("Active Channels", index);

	ret		= ai32ssc1m_ioctl(fd, AI32SSC1M_IOCTL_CHAN_ACTIVE, &set);
	errs	= ret ? 1 : 0;

	switch (set)
	{
		default:

			sprintf(buf, "INVALID: %ld", (long) set);
			break;

		case AI32SSC1M_CHAN_ACTIVE_SINGLE:

			strcpy(buf, "Single Channel (user specified)");
			break;

		case AI32SSC1M_CHAN_ACTIVE_0_1:

			strcpy(buf, "Channels 0-1");
			break;

		case AI32SSC1M_CHAN_ACTIVE_0_3:

			strcpy(buf, "Channels 0-3");
			break;

		case AI32SSC1M_CHAN_ACTIVE_0_7:

			strcpy(buf, "Channels 0-7");
			break;

		case AI32SSC1M_CHAN_ACTIVE_0_15:

			strcpy(buf, "Channels 0-15");
			break;

		case AI32SSC1M_CHAN_ACTIVE_0_31:

			strcpy(buf, "Channels 0-31");
			break;

		case AI32SSC1M_CHAN_ACTIVE_RANGE:

			strcpy(buf, "Range of Channels (user specified)");
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);

	if (get)
		get[0]	= set;

	return(errs);
}


