// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSC1M/16AI32SSC1M_Linux_1.x.x.x_DN/utils/chan_first.c $
// $Rev: 42824 $
// $Date: 2018-05-17 16:42:27 -0500 (Thu, 17 May 2018) $

// 16AI32SSC1M: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssc1m_chan_first
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSC1M_IOCTL_CHAN_FIRST service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai32ssc1m_chan_first(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("First Channel Selection", index);

	ret		= ai32ssc1m_ioctl(fd, AI32SSC1M_IOCTL_CHAN_FIRST, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf("%s  (", errs ? "FAIL <---" : "PASS");
		gsc_label_long_comma(set);
		printf(")\n");
	}

	if (get)
		get[0]	= set;

	return(errs);
}


