// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSC1M/16AI32SSC1M_Linux_1.x.x.x_DN/utils/ll_hold.c $
// $Rev: 42824 $
// $Date: 2018-05-17 16:42:27 -0500 (Thu, 17 May 2018) $

// 16AI32SSC1M: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssc1m_ll_hold
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSC1M_IOCTL_LL_HOLD service.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the board to access. Ignore if < 0.
*
*		verbose	0: errors only, !0: all output
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai32ssc1m_ll_hold(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	s32	ret;

	if (verbose)
		gsc_label_index("LL Hold Index", index);

	ret		= ai32ssc1m_ioctl(fd, AI32SSC1M_IOCTL_LL_HOLD, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (%ld)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


