// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSC1M/16AI32SSC1M_Linux_1.x.x.x_DN/utils/ll_read.c $
// $Rev: 44752 $
// $Date: 2019-05-01 13:11:11 -0500 (Wed, 01 May 2019) $

// 16AI32SSC1M: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssc1m_ll_read
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSC1M_IOCTL_LL_READ service.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the board to access. Ignore if < 0.
*
*		verbose	0: errors only, !0: all output
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai32ssc1m_ll_read(int fd, int index, int verbose, ai32ssc1m_ll_data_t* get)
{
	int					errs;
	s32					ret;
	ai32ssc1m_ll_data_t	set;

	if (verbose)
		gsc_label_index("LL Read", index);

	ret		= ai32ssc1m_ioctl(fd, AI32SSC1M_IOCTL_LL_READ, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	if (get)
		get[0]	= set;

	return(errs);
}


