// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSC1M/16AI32SSC1M_Linux_1.x.x.x_DN/utils/rx_io_mode.c $
// $Rev: 44754 $
// $Date: 2019-05-01 13:15:52 -0500 (Wed, 01 May 2019) $

// 16AI32SSC1M: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssc1m_rx_io_mode
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSC1M_IOCTL_RX_IO_MODE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	ai32ssc1m_rx_io_mode(int fd, int index, int verbose, s32 set, s32* get)
{
	char	buf[128];
	int		errs;
	int		ret;

	if (verbose)
		gsc_label_index("Rx I/O Mode", index);

	ret		= ai32ssc1m_ioctl(fd, AI32SSC1M_IOCTL_RX_IO_MODE, &set);
	errs	= ret ? 1 : 0;

	switch (set)
	{
		default:

			sprintf(buf, "INVALID: %ld", (long) set);
			break;

		case GSC_IO_MODE_PIO:

			strcpy(buf, "PIO");
			break;

		case GSC_IO_MODE_BMDMA:

			strcpy(buf, "Block Mode DMA");
			break;

		case GSC_IO_MODE_DMDMA:

			strcpy(buf, "Demand Mode DMA");
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);

	if (get)
		get[0]	= set;

	return(errs);
}


