// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSC1M/16AI32SSC1M_Linux_1.x.x.x_DN/utils/tt_const_ref_get.c $
// $Rev: 42824 $
// $Date: 2018-05-17 16:42:27 -0500 (Thu, 17 May 2018) $

// 16AI32SSC1M: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssc1m_tt_const_ref_get
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSC1M_IOCTL_TT_CONST_REF_GET service.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the board to access. Ignore if < 0.
*
*		verbose	0: errors only, !0: all output
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai32ssc1m_tt_const_ref_get(int fd, int index, int verbose, u32* get)
{
	int	errs;
	int	ret;
	u32	set;

	if (verbose)
		gsc_label_index("TT Constant/Reference Mode", index);

	ret		= ai32ssc1m_ioctl(fd, AI32SSC1M_IOCTL_TT_CONST_REF_GET, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (Constant: 0x%08lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


