// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSC1M/16AI32SSC1M_Linux_1.x.x.x_DN/utils/tt_counter.c $
// $Rev: 42824 $
// $Date: 2018-05-17 16:42:27 -0500 (Thu, 17 May 2018) $

// 16AI32SSC1M: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssc1m_tt_counter
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSC1M_IOCTL_TT_COUNTER service.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the board to access. Ignore if < 0.
*
*		verbose	0: errors only, !0: all output
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai32ssc1m_tt_counter(int fd, int index, int verbose, ai32ssc1m_tt_counter_t* get)
{
	int						errs;
	s32						ret;
	ai32ssc1m_tt_counter_t	set;

	if (verbose)
		gsc_label_index("Time Tag Counter", index);

	ret		= ai32ssc1m_ioctl(fd, AI32SSC1M_IOCTL_TT_COUNTER, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf(	"%s  (0x%05lX%08lX)\n",
				errs ? "FAIL <---" : "PASS",
				(long) set.upper,
				(long) set.lower);
	}

	if (get)
		get[0]	= set;

	return(errs);
}


